.386
.model flat, stdcall
option casemap :none

m2m MACRO M1, M2
push M2
pop  M1
ENDM

FUNC MACRO parameters:VARARG
invoke parameters
EXITM <eax>
ENDM

include \MASM32\INCLUDE\windows.inc
include \MASM32\INCLUDE\kernel32.inc
include \MASM32\INCLUDE\user32.inc
include \MASM32\INCLUDE\masm32.inc
includelib \MASM32\LIB\kernel32.lib
includelib \MASM32\LIB\user32.lib
includelib \MASM32\LIB\masm32.lib

.data
pluginname db "Winamp2RnQ v1.1",0
dot db '. ',0
cuttext db ' - Winamp',0
lacuttext db ' - Light Alloy',0
exstclassname db 'TxStatusForm',0
hExstform dd 0
hEdit dd 0
hMemo dd 0
hButton dd 0
editclass db 'TEdit',0
memoclass db 'TMemo',0
buttonclass db 'TRnQButton',0
winampclass  db 'Winamp v1.x',0
laclass db 'LightAlloyFront',0
tiptexton db ' Winamp2RnQ',0
tiptextoff db ' Winamp2RnQ',0
configname db 'wa2rnq.dat',0
hTimer dd 0
hWinamp dd 0
player dd 0 ; 1 - WA, 2 - LA

stWork dd 1
stText dd 3

.data?
hInstance dd ?
hDll dd ?
classnamebuffer db 32 dup (?)
hIconon dd ?
hIconoff dd ?
buttId dd ?
hDlg dd ?
hFile dd ?
songbuffer db 256 dup (?)
oldsongbuffer db 256 dup (?)
oldstatusbuffer db 256 dup (?)
userpath db 256 dup (?)
bytesread dd ?

include plugin.inc
include callexec.inc

EnumChilds proto :DWORD,:DWORD
TimerProc proto :DWORD,:DWORD,:DWORD,:DWORD
UpdateSong proto:DWORD
ButtonProc proto :DWORD
Preferences proto
DlgProc proto :DWORD,:DWORD,:DWORD,:DWORD

.code

LibMain proc hInstDLL:DWORD, reason:DWORD, unused:DWORD
.if reason == DLL_PROCESS_ATTACH
	m2m hDll,hInstDLL
	xor eax,eax
	invoke GetModuleHandle,eax
	mov hInstance,eax
	invoke LoadIcon,hInstDLL,101
	mov hIconon,eax
	invoke LoadIcon,hInstDLL,102
	mov hIconoff,eax
	xor eax,eax
	inc eax
	ret
.endif
ret
LibMain Endp

pluginFun proc data:DWORD
	mov eax,data
	xor ecx,ecx
	mov cl, [eax+4]
	.if ecx == PM_EVENT
		mov cl, [eax+5]
		.if ecx == PE_INITIALIZE
			mov ecx, [eax+6]
			mov callback, ecx
			mov ecx,[eax+14]
			add eax,ecx
			add eax,18
			mov ecx,[eax]
			push ecx
			add eax,4
			invoke MemCopy,eax,addr userpath,ecx
			pop eax
			add eax, offset userpath
			mov byte ptr [eax],0
			invoke lstrcat, addr userpath, addr configname
			xor eax,eax
			invoke CreateFile, addr userpath, GENERIC_READ,FILE_SHARE_READ,eax,OPEN_EXISTING,eax,eax
			.if eax != INVALID_HANDLE_VALUE
				mov hFile, eax
				invoke ReadFile,hFile,addr stWork,8,addr bytesread,0
				invoke CloseHandle, hFile
			.endif
			.if stWork == 1
				invoke RQ_CreateChatButton,addr ButtonProc,hIconon,addr tiptexton
			.elseif
				invoke RQ_CreateChatButton,addr ButtonProc,hIconoff,addr tiptextoff
			.endif
			mov buttId, eax
			
			mov byte ptr buffer, PM_DATA
			invoke lstrlen, addr pluginname
			mov dword ptr buffer+1,eax
			push eax
			invoke lstrcpy, offset buffer+5, addr pluginname
			add eax,dword ptr buffer+1
			mov dword ptr [eax],4
			pop eax
			add eax,9
			invoke str2comm, addr buffer,eax
			ret
		.elseif ecx == PE_CONNECTED
			.if hTimer == 0
				invoke EnumWindows,addr EnumChilds,ecx
				invoke GetWindowText,hMemo,addr oldstatusbuffer,255
				invoke TimerProc,hExstform,WM_TIMER,666,0
				invoke SetTimer,hExstform,666,1000,addr TimerProc
				mov hTimer, eax
			.endif
		.elseif ecx == PE_FINALIZE
			invoke KillTimer,hExstform,666
			invoke RQ_DeleteChatButton,buttId
			call SaveSettings
			invoke UpdateSong, addr oldstatusbuffer
		.elseif ecx == PE_PREFERENCES
			invoke Preferences
		.endif
	.endif
	xor eax,eax
ret
pluginFun endp

EnumChilds proc hChild : DWORD, sux : DWORD
	invoke GetClassName,hChild,addr classnamebuffer, 32
	.if sux == PE_CONNECTED
		invoke lstrcmp,addr classnamebuffer,addr exstclassname
		jnz next
		invoke GetWindowLong,hChild,GWL_HINSTANCE
		cmp eax,hInstance
		jne next
		m2m hExstform,hChild
		invoke EnumChildWindows,hChild,addr EnumChilds,0
		xor eax,eax
		ret
	.else
		invoke lstrcmp,addr classnamebuffer,addr editclass
		jnz cmpmemo
		m2m hEdit,hChild
		jmp short next
cmpmemo:
		invoke lstrcmp,addr classnamebuffer,addr memoclass
		jnz cmpbutton
		.if stWork == 1 && hMemo == 0
			invoke GetWindowText,hChild,addr oldstatusbuffer,255
			mov byte ptr oldsongbuffer,0
		.endif
		m2m hMemo,hChild
		jmp short next
cmpbutton:
		invoke lstrcmp,addr classnamebuffer,addr buttonclass
		jnz next
		m2m hButton,hChild
	.endif
next:
	xor eax,eax
	inc eax
ret
EnumChilds endp

TimerProc proc hWnd:DWORD, uMsg:DWORD, idEvent:DWORD, dwTime:DWORD
	.if stWork != 1
		invoke GetWindowText,hMemo,addr oldstatusbuffer,255		
	.else
		.if hMemo == 0
			invoke EnumWindows,addr EnumChilds,PE_CONNECTED
			jmp exit
		.endif
		invoke FindWindow,addr laclass,0
		mov hWinamp,eax
		.if eax == 0
			invoke FindWindow,addr winampclass,0
			.if eax != 0
				mov player, 1
			.endif
		.else
			mov player, 2
		.endif
		mov hWinamp,eax
		.if eax == 0
noplayers:
			.if player !=0
				mov player, 0
				invoke UpdateSong, addr oldstatusbuffer
			.else
				invoke GetWindowText,hMemo,addr oldstatusbuffer,255			
			.endif
			jmp exit
		.else
			call GetSong
			cmp byte ptr songbuffer,0
			jz noplayers
			.if stText == 1
				invoke lstrcpy, addr buffer, addr oldstatusbuffer
				invoke lstrcat, addr buffer, addr songbuffer
				invoke lstrcpy, addr songbuffer, addr buffer
			.elseif stText == 2
				invoke lstrcat, addr songbuffer, addr oldstatusbuffer
			.endif
			
			invoke lstrcmp,addr songbuffer,addr oldsongbuffer
			test eax,eax
			jz exit
			invoke UpdateSong, addr songbuffer
			invoke lstrcpy,addr oldsongbuffer,addr songbuffer
		.endif
	.endif
exit:
ret
TimerProc endp

UpdateSong proc sb:DWORD
	invoke GetActiveWindow
	push eax
	invoke SendMessage,hMemo,WM_SETTEXT,0,sb
	xor eax,eax
	invoke SendMessage,hButton,BM_CLICK,eax,eax
	call SetActiveWindow
ret
UpdateSong endp

ButtonProc proc buttstate:DWORD
	.if stWork == 1
		call SwitchOff
	.else
		call SwitchOn
	.endif
ret
ButtonProc endp

Preferences proc
	invoke DialogBoxParam,hDll,200,0,addr DlgProc,0
ret
Preferences endp

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
.if uMsg == WM_INITDIALOG

     push hWnd
     pop hDlg
     invoke LoadIcon,hDll,101
     invoke SendMessage,hWnd,WM_SETICON,NULL,eax
     .if stText == 1
     	invoke CheckRadioButton,hDlg,201,203,201
     .elseif stText == 2
     	invoke CheckRadioButton,hDlg,201,203,202
     .else
     	invoke CheckRadioButton,hDlg,201,203,203
     .endif     
.elseif uMsg == WM_CLOSE
	invoke EndDialog,hWnd,0

.elseif uMsg == WM_COMMAND
	mov eax, wParam
	.if eax == 204
		invoke EndDialog,hWnd,0
	.elseif eax == 205
		invoke IsDlgButtonChecked,hWnd,201
		.if eax == BST_CHECKED
			mov stText,1
		.else
			invoke IsDlgButtonChecked,hWnd,202
			.if eax == BST_CHECKED
				mov stText,2
			.else
				mov stText,3
			.endif
		.endif
		call SaveSettings
		invoke EndDialog,hWnd,0
	.endif
.endif
unknown:
	xor eax,eax
ret
DlgProc endp

SwitchOn proc
	mov stWork,1
	invoke RQ_ModifyChatButton,buttId,hIconon,addr tiptexton
	invoke GetWindowText,hMemo,addr oldstatusbuffer,255
	.if hMemo == 0
		invoke EnumWindows,addr EnumChilds,PE_CONNECTED
	.endif
	mov byte ptr oldsongbuffer,0
ret
SwitchOn endp

SwitchOff proc
	mov stWork,0
	invoke RQ_ModifyChatButton,buttId,hIconoff,addr tiptextoff
	invoke UpdateSong, addr oldstatusbuffer
ret
SwitchOff endp

SaveSettings proc
	xor eax,eax
	invoke CreateFile, addr userpath, GENERIC_WRITE,FILE_SHARE_READ,eax,CREATE_ALWAYS,eax,eax
	.if eax != INVALID_HANDLE_VALUE
		mov hFile, eax
		invoke WriteFile,hFile,addr stWork,8,addr bytesread,0
		invoke CloseHandle, hFile
	.endif
ret
SaveSettings endp

GetSong proc
	.if player == 1
		invoke GetWindowText,hWinamp,addr buffer,255
		invoke lstrlen, addr buffer
		invoke SBMBinSearch,0,addr buffer,eax,addr cuttext,9
		cmp eax, -1
		je error
		add eax, offset buffer
		mov byte ptr [eax],0
		invoke lstrlen, addr buffer
		invoke SBMBinSearch,0,addr buffer,eax,addr dot,2
		add eax,2
		add eax, offset buffer
		invoke lstrcpy, addr songbuffer, eax
	.elseif player == 2
		invoke GetWindowText,hWinamp,addr songbuffer,255
		invoke lstrlen, addr songbuffer
		invoke SBMBinSearch,0,addr songbuffer,eax,addr lacuttext,14
		cmp eax, -1
		je error
		add eax, offset songbuffer
		mov byte ptr [eax],0
	.endif
ret
error:
pop eax
mov byte ptr songbuffer,0
ret
GetSong endp
End LibMain